#if ! defined( CMSTF_CLASS_HEADER )

/*
** Author: Samuel R. Blackburn
** CI$: 76300,326
** Internet: sammy@sed.csc.com
**
** You can use it any way you like as long as you don't try to sell it.
**
** Any attempt to sell WFC in source code form must have the permission
** of the original author. You can produce commercial executables with
** WFC but you can't sell WFC.
**
** Copyright, 1995, Samuel R. Blackburn
**
** $Workfile: $
** $Revision: $
** $Modtime: $
*/

#define CMSTF_CLASS_HEADER

#if ! defined( SAMS_MICROSOFT_TAPE_FORMAT_HEADER )
#include "samtf.h"
#endif

class CUINT64 : public UINT64
{
   public:

      CUINT64();
      CUINT64( const CUINT64& source );
      CUINT64( const UINT64 * source );
      virtual ~CUINT64();
      virtual void Copy( const CUINT64& source );
      virtual void Copy( const UINT64 * source );
      virtual void Empty( void );

#if defined( _DEBUG )

      virtual void Dump( CDumpContext& dump_context ) const;

#endif
};

class CMTFDateTime : public MTF_DATE_TIME
{
   public:

      CMTFDateTime();
      CMTFDateTime( const CMTFDateTime& source );
      CMTFDateTime( const MTF_DATE_TIME * source );
      virtual ~CMTFDateTime();
      virtual void Convert( CTime& destination ) const;
      virtual void Copy( const CMTFDateTime& source );
      virtual void Copy( const MTF_DATE_TIME * source );
      virtual void Copy( const CTime& source );
      virtual void Empty( void );

#if defined( _DEBUG )

      virtual void Dump( CDumpContext& dump_context ) const;

#endif
};

class CMTFTapeAddress : public MTF_TAPE_ADDRESS
{
   public:

      CMTFTapeAddress();
      CMTFTapeAddress( const CMTFTapeAddress& source );
      CMTFTapeAddress( const MTF_TAPE_ADDRESS * source );
      virtual ~CMTFTapeAddress();
      virtual void Copy( const CMTFTapeAddress& source );
      virtual void Copy( const MTF_TAPE_ADDRESS * source );
      virtual void Empty( void );

#if defined( _DEBUG )

      virtual void Dump( CDumpContext& dump_context ) const;

#endif
};

class CMTFDataBlockHeader : public MTF_DB_HDR
{
   public:

      CMTFDataBlockHeader();
      CMTFDataBlockHeader( const CMTFDataBlockHeader& source );
      CMTFDataBlockHeader( const MTF_DB_HDR * source );
      virtual ~CMTFDataBlockHeader();
      virtual void Copy( const CMTFDataBlockHeader& source );
      virtual void Copy( const MTF_DB_HDR * source );
      virtual void Empty( void );

#if defined( _DEBUG )

      virtual void Dump( CDumpContext& dump_context ) const;

#endif
};

class CMTFTape : public MTF_TAPE
{
   public:

      CMTFTape();
      CMTFTape( const CMTFTape& source );
      CMTFTape( const MTF_TAPE * source );
      virtual ~CMTFTape();
      virtual void Copy( const CMTFTape& source );
      virtual void Copy( const MTF_TAPE * source );
      virtual void Empty( void );

#if defined( _DEBUG )

      virtual void Dump( CDumpContext& dump_context ) const;

#endif
};

#endif // CMSTF_CLASS_HEADER
